package com.search.supersearch.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * @author 喜欢番茄火锅
 * @date 2023/9/14 14:22
 */
@Data
public class SearchByCommonIdDTO {

    @ApiModelProperty(value = "索引", required = true)
    @NotNull
    private List<String> index;

    @ApiModelProperty(value = "关联ID", required = true)
    @NotNull
    private List<String> commonId;

}
