package com.search.supersearch.model.pojo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author 喜欢番茄火锅
 * @date 2023/9/14 14:58
 */
@Data
public class SearchType {
    @ApiModelProperty(value = "组织编码字段")
    private String orgCodeFiled;
    /**
     * ES索引名称
     */

    @ApiModelProperty(value = "ES索引名称")
    private String indexName;
    /**
     * ES索引备注
     */

    @ApiModelProperty(value = "ES索引备注")
    private String indexRemark;

    /**
     * 系统ID
     */

    @ApiModelProperty(value = "系统ID")
    private String systemId;
    /**
     * 系统名称
     */

    @ApiModelProperty(value = "系统名称 ")
    private String systemName;
    /**
     * 系统来源名称
     */

    @ApiModelProperty(value = "系统来源名称")
    private String indexSource;
    /**
     * 索引类型 0 非结构化  1 结构化
     */

    @ApiModelProperty(value = "索引类型 0 非结构化  1 结构化")
    private Integer type;

    @ApiModelProperty(value = "索引存在是否删除 0 删除 1 不删除")
    private Integer deleteIndex;
    @ApiModelProperty(value = "副本数量")
    private String numberOfReplicas;
    @ApiModelProperty(value = "分片数量")
    private String numberOfShards;
}
