package com.search.supersearch.model.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;

import java.io.Serializable;
import java.util.List;

/**
 * @author 喜欢番茄火锅
 * @date 2023/10/10 16:14
 */
@NoArgsConstructor
@Data
@AllArgsConstructor
@ToString
public class DocsIndexCountTreeVO implements Serializable {
    private static final long serialVersionUID = 1L;
    @ApiModelProperty(value = "编码")
    private String type;
    @ApiModelProperty(value = "名称")
    private String name;
    @ApiModelProperty(value = "数量")
    private Long total;
    @ApiModelProperty(value = "信息")
    private List<DocsIndexCountTreeVO> info;

}
